diff -Naur --exclude=CVS --exclude=configs linux/fs/proc/base.c linux-openmosix/fs/proc/base.c
--- linux/fs/proc/base.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/proc/base.c	2004-02-05 10:51:23.000000000 +0100
@@ -26,6 +26,11 @@
 #include <linux/seq_file.h>
 #include <linux/namespace.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#include <linux/smp_lock.h>
+#endif /* CONFIG_MOSIX */
+
 /*
  * For hysterical raisins we keep the same inumbers as in the old procfs.
  * Feel free to change the macro below - just keep the range distinct from
@@ -40,6 +45,21 @@
 int proc_pid_status(struct task_struct*,char*);
 int proc_pid_statm(struct task_struct*,char*);
 int proc_pid_cpu(struct task_struct*,char*);
+#ifdef CONFIG_MOSIX
+int proc_pid_where(struct task_struct*,char*);
+int proc_pid_nmigs(struct task_struct*,char*);
+int proc_pid_cantmove(struct task_struct*,char*);
+int proc_pid_lock(struct task_struct*,char*);
+int proc_pid_sigmig(struct task_struct*,char*);
+int proc_pid_disclosure(struct task_struct*,char*);
+int proc_pid_migfilter(struct task_struct*,char*);
+int proc_pid_migpolicy(struct task_struct*,char*);
+int proc_pid_mignodes(struct task_struct*,char*);
+int proc_pid_miggroup(struct task_struct*,char*);
+#endif /* CONFIG_MOSIX */
+#ifdef CONFIG_MOSIX_FS
+int proc_pid_selected(struct task_struct*,char*);
+#endif /* CONFIG_MOSIX_FS */
 
 static int proc_fd_link(struct inode *inode, struct dentry **dentry, struct vfsmount **mnt)
 {
@@ -51,6 +71,32 @@
 	return -ENOENT;
 }
 
+#ifdef CONFIG_MOSIX
+struct file *
+first_executable(void)
+{
+	struct mm_struct *mm = current->mm;
+	register struct vm_area_struct *vma;
+	struct file *f = NULL;
+
+	if(!mm)
+		return(NULL);
+	down_read(&mm->mmap_sem);
+	for(vma = current->mm->mmap ; vma ; vma = vma->vm_next)
+	if ((vma->vm_flags & VM_EXECUTABLE) && vma->vm_file)
+	{
+		f = vma->vm_file;
+		if(current->mosix.dflags & DREMOTE)
+			f = home_file(f);
+		else
+			get_file(f);
+		break;
+	}
+	up_read(&mm->mmap_sem);
+	return(f);
+}
+#endif /* CONFIG_MOSIX */
+
 static int proc_exe_link(struct inode *inode, struct dentry **dentry, struct vfsmount **mnt)
 {
 	struct mm_struct * mm;
@@ -59,6 +105,24 @@
 	struct task_struct *task = inode->u.proc_i.task;
 
 	task_lock(task);
+#ifdef CONFIG_MOSIX
+	if(SHOULD_ASK_PROCESS(task))
+	{
+		struct file *f;
+
+		task_unlock(task);
+		f = (struct file *)request_process(task, &f,
+							PR_PROCFS_GET_EXE, 0);
+		if(f && !IS_ERR(f))
+		{
+			*mnt = mntget(f->f_vfsmnt);
+			*dentry = dget(f->f_dentry);
+			result = 0;
+			fput(f);
+		}
+		goto out;
+	}
+#endif /* CONFIG_MOSIX */
 	mm = task->mm;
 	if (mm)
 		atomic_inc(&mm->mm_users);
@@ -87,6 +151,12 @@
 {
 	struct fs_struct *fs;
 	int result = -ENOENT;
+#ifdef CONFIG_MOSIX_DFSA
+	struct task_struct *p = inode->u.proc_i.task;
+
+	if(SHOULD_ASK_PROCESS(p))
+		request_process(p, NULL, PR_DFSA_SYNCHRONIZE, 0);
+#endif /* CONFIG_MOSIX_DFSA */
 	task_lock(inode->u.proc_i.task);
 	fs = inode->u.proc_i.task->fs;
 	if(fs)
@@ -153,36 +223,56 @@
 	return retval;
 }
 
+#ifdef CONFIG_MOSIX
+int proc_pid_environ(struct task_struct *task, char * buffer)
+#else
 static int proc_pid_environ(struct task_struct *task, char * buffer)
+#endif /* CONFIG_MOSIX */
 {
 	struct mm_struct *mm;
 	int res = 0;
-
-	if (!may_ptrace_attach(task))
-		return -ESRCH;
-
+ 	if (!may_ptrace_attach(task))
+ 		return -ESRCH;
 	task_lock(task);
+#ifdef CONFIG_MOSIX
+	if(SHOULD_ASK_PROCESS(task))
+	{
+		task_unlock(task);
+		return(request_process(task, buffer, PR_PROCFS_GET_ENV, 0));
+	}
+#endif /* CONFIG_MOSIX */
 	mm = task->mm;
 	if (mm)
 		atomic_inc(&mm->mm_users);
 	task_unlock(task);
 	if (mm) {
-		unsigned int len = mm->env_end - mm->env_start;
+ 		unsigned int len = mm->env_end - mm->env_start;
 		if (len > PAGE_SIZE)
 			len = PAGE_SIZE;
 		res = access_process_vm(task, mm->env_start, buffer, len, 0);
-		if (!may_ptrace_attach(task))
-			res = -ESRCH;
+ 		if (!may_ptrace_attach(task))
+ 			res = -ESRCH;
 		mmput(mm);
 	}
 	return res;
 }
 
+#ifdef CONFIG_MOSIX
+int proc_pid_cmdline(struct task_struct *task, char * buffer)
+#else
 static int proc_pid_cmdline(struct task_struct *task, char * buffer)
+#endif /* CONFIG_MOSIX */
 {
 	struct mm_struct *mm;
 	int res = 0;
 	task_lock(task);
+#ifdef CONFIG_MOSIX
+	if(SHOULD_ASK_PROCESS(task))
+	{
+		task_unlock(task);
+		return(request_process(task, buffer, PR_PROCFS_GET_ARG, 0));
+	}
+#endif /* CONFIG_MOSIX */
 	mm = task->mm;
 	if (mm)
 		atomic_inc(&mm->mm_users);
@@ -233,6 +323,10 @@
 	our_vfsmnt = mntget(current->fs->rootmnt);
 	base = dget(current->fs->root);
 	read_unlock(&current->fs->lock);
+#ifdef CONFIG_MOSIX
+	if(!root)	/* hope it will be fixed by 2.4.0 */
+		return(-ENOENT);
+#endif /* CONFIG_MOSIX */
 
 	spin_lock(&dcache_lock);
 	de = root;
@@ -367,6 +461,7 @@
 	read:		proc_info_read,
 };
 
+
 static int mem_open(struct inode* inode, struct file* file)
 {
 	file->private_data = (void*)((long)current->self_exec_id);
@@ -394,12 +489,18 @@
 	if (mm)
 		atomic_inc(&mm->mm_users);
 	task_unlock(task);
+#ifndef CONFIG_MOSIX
 	if (!mm){
 		copied = 0;
 		goto out_free;
 	}
+#endif /* CONFIG_MOSIX */
+
 
 	if (file->private_data != (void*)((long)current->self_exec_id) ) {
+#ifdef CONFIG_MOSIX
+	  	if (mm)
+#endif /* CONFIG_MOSIX */
 		mmput(mm);
 		copied = -EIO;
 		goto out_free;
@@ -425,6 +526,9 @@
 		count -= retval;
 	}
 	*ppos = src;
+#ifdef CONFIG_MOSIX
+	if(mm)
+#endif /* CONFIG_MOSIX */
 	mmput(mm);
 
 out_free:
@@ -598,6 +702,24 @@
 	PROC_PID_STATM,
 	PROC_PID_MAPS,
 	PROC_PID_CPU,
+#ifdef CONFIG_MOSIX
+	PROC_PID_WHERE,
+	PROC_PID_MIGRATE,
+	PROC_PID_GOTO,
+	PROC_PID_LOCK,
+	PROC_PID_NMIGS,
+	PROC_PID_CANTMOVE,
+	PROC_PID_SIGMIG,
+	PROC_PID_DISCLOSURE,
+	PROC_PID_MIGFILTER,
+	PROC_PID_MIGPOLICY,
+	PROC_PID_MIGNODES,
+	PROC_PID_MIGGROUP,
+#ifdef CONFIG_MOSIX_FS
+	PROC_PID_SELECTED,
+#endif /* CONFIG_MOSIX_FS */
+	PROC_PID_MOSIX_START = PROC_MOSIX_USE_START,
+#endif /* CONFIG_MOSIX */
 	PROC_PID_MOUNTS,
 	PROC_PID_FD_DIR = 0x8000,	/* 0x8000-0xffff */
 };
@@ -619,6 +741,23 @@
   E(PROC_PID_ROOT,	"root",		S_IFLNK|S_IRWXUGO),
   E(PROC_PID_EXE,	"exe",		S_IFLNK|S_IRWXUGO),
   E(PROC_PID_MOUNTS,	"mounts",	S_IFREG|S_IRUGO),
+#ifdef CONFIG_MOSIX
+  E(PROC_PID_WHERE,	"where",	S_IFREG|S_IRUGO),
+  E(PROC_PID_MIGRATE,	"migrate",	S_IFREG|S_IWUSR),
+  E(PROC_PID_GOTO,	"goto",		S_IFREG|S_IWUGO),
+  E(PROC_PID_LOCK,	"lock",		S_IFREG|S_IRUGO|S_IWUSR),
+  E(PROC_PID_NMIGS,	"nmigs",	S_IFREG|S_IRUGO),
+  E(PROC_PID_CANTMOVE,	"cantmove",	S_IFREG|S_IRUGO),
+  E(PROC_PID_SIGMIG,	"sigmig",	S_IFREG|S_IRUGO|S_IWUSR),
+  E(PROC_PID_DISCLOSURE,"disclosure",	S_IFREG|S_IRUGO|S_IWUSR),
+  E(PROC_PID_MIGFILTER,	"migfilter",	S_IFREG|S_IRUGO|S_IWUSR),
+  E(PROC_PID_MIGPOLICY,	"migpolicy",	S_IFREG|S_IRUGO|S_IWUSR),
+  E(PROC_PID_MIGNODES,	"mignodes",	S_IFREG|S_IRUGO|S_IWUSR),
+  E(PROC_PID_MIGGROUP,  "miggroup",	S_IFREG|S_IRUGO|S_IWUSR),
+#endif /* CONFIG_MOSIX */
+#ifdef CONFIG_MOSIX_FS
+  E(PROC_PID_SELECTED,	"selected",	S_IFREG|S_IRUGO|S_IWUSR),
+#endif /* CONFIG_MOSIX_FS */
   {0,0,NULL,0}
 };
 #undef E
@@ -649,6 +788,10 @@
 				goto out;
 			filp->f_pos++;
 		default:
+#ifdef CONFIG_MOSIX_DFSA
+			if(SHOULD_ASK_PROCESS(p))
+				request_process(p, NULL, PR_DFSA_SYNCHRONIZE,0);
+#endif /* CONFIG_MOSIX_DFSA */
 			task_lock(p);
 			files = p->files;
 			if (files)
@@ -731,7 +874,11 @@
 
 /* building an inode */
 
+#ifdef CONFIG_MOSIX
+int task_dumpable(struct task_struct *task)
+#else
 static int task_dumpable(struct task_struct *task)
+#endif /* CONFIG_MOSIX */
 {
 	int dumpable = 0;
 	struct mm_struct *mm;
@@ -740,6 +887,11 @@
 	mm = task->mm;
 	if (mm)
 		dumpable = mm->dumpable;
+#ifdef CONFIG_MOSIX
+	else if((current->mosix.dflags & (DDEPUTY|DDUMPABLE)) ==
+							(DDEPUTY|DDUMPABLE))
+		dumpable = 1;
+#endif /* CONFIG_MOSIX */
 	task_unlock(task);
 	return dumpable;
 }
@@ -856,6 +1008,10 @@
 	inode = proc_pid_make_inode(dir->i_sb, task, PROC_PID_FD_DIR+fd);
 	if (!inode)
 		goto out;
+#ifdef CONFIG_MOSIX_DFSA
+	if(SHOULD_ASK_PROCESS(task))
+		request_process(task, NULL, PR_DFSA_SYNCHRONIZE,0);
+#endif /* CONFIG_MOSIX_DFSA */
 	task_lock(task);
 	files = task->files;
 	if (files)
@@ -904,6 +1060,64 @@
 	permission:	proc_permission,
 };
 
+#ifdef CONFIG_MOSIX
+static int
+proc_pid_writeonly(struct task_struct *doesnt_matter, char *buf)
+{
+	return(-EPERM);
+}
+
+static ssize_t
+proc_mosix_write(struct file *file, const char *buf, size_t cnt, loff_t *ppos)
+{
+	struct inode * inode = file->f_dentry->d_inode;
+	ssize_t result = -EPERM;
+	struct task_struct *task = inode->u.proc_i.task;
+
+	switch(inode->i_ino & 0xffff)
+	{
+	    case PROC_PID_MIGRATE:
+		result = proc_mosix_pid_set_migrate(file, task, buf, cnt);
+		break;
+	    case PROC_PID_GOTO:
+		result = proc_mosix_pid_set_goto(file, task, buf, cnt);
+		break;
+	    case PROC_PID_LOCK:
+		result = proc_mosix_pid_set_lock(file, task, buf, cnt);
+		break;
+	    case PROC_PID_SIGMIG:
+		result = proc_mosix_pid_set_sigmig(file, task, buf, cnt);
+		break;
+	    case PROC_PID_DISCLOSURE:
+		result = proc_mosix_pid_set_disclosure(file, task, buf, cnt);
+		break;
+	    case PROC_PID_MIGFILTER:
+		result = proc_mosix_pid_set_migfilter(file, task, buf, cnt);
+		break;
+	    case PROC_PID_MIGPOLICY:
+		result = proc_mosix_pid_set_migpolicy(file, task, buf, cnt);
+		break;
+	    case PROC_PID_MIGNODES:
+		result = proc_mosix_pid_set_mignodes(file, task, buf, cnt);
+		break;
+            case PROC_PID_MIGGROUP:
+                result = proc_mosix_pid_set_miggroup(file, task, buf, cnt);
+                break;
+#ifdef CONFIG_MOSIX_FS
+	    case PROC_PID_SELECTED:
+		result = proc_mosix_pid_set_selected(file, task, buf, cnt);
+		break;
+#endif /* CONFIG_MOSIX_FS */
+	}
+	return(result);
+}
+
+static struct file_operations proc_mosix_file_operations = {
+	read: proc_info_read,
+	write: proc_mosix_write,
+};
+#endif /* CONFIG_MOSIX */
+
 static struct dentry *proc_base_lookup(struct inode *dir, struct dentry *dentry)
 {
 	struct inode *inode;
@@ -987,6 +1201,62 @@
 		case PROC_PID_MOUNTS:
 			inode->i_fop = &proc_mounts_operations;
 			break;
+#ifdef CONFIG_MOSIX
+		case PROC_PID_WHERE:
+			inode->i_fop = &proc_info_file_operations;
+			inode->u.proc_i.op.proc_read = proc_pid_where;
+			break;
+		case PROC_PID_NMIGS:
+			inode->i_fop = &proc_info_file_operations;
+			inode->u.proc_i.op.proc_read = proc_pid_nmigs;
+			break;
+		case PROC_PID_CANTMOVE:
+			inode->i_fop = &proc_info_file_operations;
+			inode->u.proc_i.op.proc_read = proc_pid_cantmove;
+			break;
+		case PROC_PID_MIGRATE:
+			inode->i_fop = &proc_mosix_file_operations;
+			inode->u.proc_i.op.proc_read = proc_pid_writeonly;
+			break;
+		case PROC_PID_GOTO:
+			inode->i_fop = &proc_mosix_file_operations;
+			inode->u.proc_i.op.proc_read = proc_pid_writeonly;
+			break;
+		case PROC_PID_LOCK:
+			inode->i_fop = &proc_mosix_file_operations;
+			inode->u.proc_i.op.proc_read = proc_pid_lock;
+			break;
+		case PROC_PID_SIGMIG:
+			inode->i_fop = &proc_mosix_file_operations;
+			inode->u.proc_i.op.proc_read = proc_pid_sigmig;
+			break;
+		case PROC_PID_DISCLOSURE:
+			inode->i_fop = &proc_mosix_file_operations;
+			inode->u.proc_i.op.proc_read = proc_pid_disclosure;
+			break;
+		case PROC_PID_MIGFILTER:
+			inode->i_fop = &proc_mosix_file_operations;
+			inode->u.proc_i.op.proc_read = proc_pid_migfilter;
+			break;
+		case PROC_PID_MIGPOLICY:
+			inode->i_fop = &proc_mosix_file_operations;
+			inode->u.proc_i.op.proc_read = proc_pid_migpolicy;
+			break;
+		case PROC_PID_MIGNODES:
+			inode->i_fop = &proc_mosix_file_operations;
+			inode->u.proc_i.op.proc_read = proc_pid_mignodes;
+			break;
+                case PROC_PID_MIGGROUP:
+                        inode->i_fop = &proc_mosix_file_operations;
+                        inode->u.proc_i.op.proc_read = proc_pid_miggroup;
+                        break;
+#endif /* CONFIG_MOSIX */
+#ifdef CONFIG_MOSIX_FS
+		case PROC_PID_SELECTED:
+			inode->i_fop = &proc_mosix_file_operations;
+			inode->u.proc_i.op.proc_read = proc_pid_selected;
+			break;
+#endif /* CONFIG_MOSIX_FS */
 		default:
 			printk("procfs: impossible type (%d)",p->type);
 			iput(inode);
@@ -1101,6 +1371,14 @@
 {
 	if (inode->u.proc_i.file)
 		fput(inode->u.proc_i.file);
+#ifdef CONFIG_MOSIX
+	{
+		int ino = inode->i_ino & 0xffff;
+
+		if(ino >= PROC_PID_MOSIX_START && ino < PROC_PID_FD_DIR)
+			return;
+	}
+#endif /* CONFIG_MOSIX */
 	if (inode->u.proc_i.task)
 		free_task_struct(inode->u.proc_i.task);
 }
@@ -1120,7 +1398,11 @@
 
 	index--;
 	read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	for_each_local_task(p) {
+#else
 	for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 		int pid = p->pid;
 		if (!pid)
 			continue;
diff -Naur --exclude=CVS --exclude=configs linux/fs/proc/generic.c linux-openmosix/fs/proc/generic.c
--- linux/fs/proc/generic.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/proc/generic.c	2004-02-05 10:51:23.000000000 +0100
@@ -359,7 +359,11 @@
 	lookup:		proc_lookup,
 };
 
+#ifdef CONFIG_MOSIX
+int proc_register(struct proc_dir_entry * dir, struct proc_dir_entry * dp)
+#else
 static int proc_register(struct proc_dir_entry * dir, struct proc_dir_entry * dp)
+#endif /* CONFIG_MOSIX */
 {
 	int	i;
 	
diff -Naur --exclude=CVS --exclude=configs linux/fs/proc/inode.c linux-openmosix/fs/proc/inode.c
--- linux/fs/proc/inode.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/proc/inode.c	2004-02-05 10:51:23.000000000 +0100
@@ -195,7 +195,11 @@
 	 * Fixup the root inode's nlink value
 	 */
 	read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	for_each_local_task(p) if (p->pid) root_inode->i_nlink++;
+#else
 	for_each_task(p) if (p->pid) root_inode->i_nlink++;
+#endif /* CONFIG_MOSIX */
 	read_unlock(&tasklist_lock);
 	s->s_root = d_alloc_root(root_inode);
 	if (!s->s_root)
diff -Naur --exclude=CVS --exclude=configs linux/fs/proc/proc_misc.c linux-openmosix/fs/proc/proc_misc.c
--- linux/fs/proc/proc_misc.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/proc/proc_misc.c	2004-02-05 10:51:23.000000000 +0100
@@ -157,7 +157,7 @@
 {
 	struct sysinfo i;
 	int len;
-	int pg_size ;
+	int pg_size, committed;
 
 /*
  * display in kilobytes.
@@ -194,7 +194,8 @@
 		"LowTotal:     %8lu kB\n"
 		"LowFree:      %8lu kB\n"
 		"SwapTotal:    %8lu kB\n"
-		"SwapFree:     %8lu kB\n",
+		"SwapFree:     %8lu kB\n"
+		"Committed_AS: %8u kB\n",
 		K(i.totalram),
 		K(i.freeram),
 		K(i.sharedram),
@@ -208,7 +209,8 @@
 		K(i.totalram-i.totalhigh),
 		K(i.freeram-i.freehigh),
 		K(i.totalswap),
-		K(i.freeswap));
+		K(i.freeswap),
+		K(committed));
 
 	return proc_calc_metrics(page, start, off, count, eof, len);
 #undef B
diff -Naur --exclude=CVS --exclude=configs linux/fs/proc/root.c linux-openmosix/fs/proc/root.c
--- linux/fs/proc/root.c	2002-08-03 02:39:45.000000000 +0200
+++ linux-openmosix/fs/proc/root.c	2004-02-05 10:51:23.000000000 +0100
@@ -4,6 +4,7 @@
  *  Copyright (C) 1991, 1992 Linus Torvalds
  *
  *  proc root directory handling functions
+ *  addes some stuff for openMosix (/proc/hpc)
  */
 
 #include <asm/uaccess.h>
@@ -17,7 +18,14 @@
 #include <linux/module.h>
 #include <asm/bitops.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 struct proc_dir_entry *proc_net, *proc_bus, *proc_root_fs, *proc_root_driver;
+#ifdef CONFIG_MOSIX
+struct proc_dir_entry *proc_mosix;
+#endif /* CONFIG_MOSIX */
 
 #ifdef CONFIG_SYSCTL
 struct proc_dir_entry *proc_sys_root;
@@ -48,6 +56,10 @@
 	proc_mkdir("sys/fs", 0);
 	proc_mkdir("sys/fs/binfmt_misc", 0);
 #endif
+#ifdef CONFIG_MOSIX
+	proc_mosix = proc_mkdir("hpc", 0);
+	mosix_proc_init();
+#endif /* CONFIG_MOSIX */
 	proc_root_fs = proc_mkdir("fs", 0);
 	proc_root_driver = proc_mkdir("driver", 0);
 #if defined(CONFIG_SUN_OPENPROMFS) || defined(CONFIG_SUN_OPENPROMFS_MODULE)
@@ -76,6 +88,9 @@
 		int nlink = proc_root.nlink;
 
 		nlink += nr_threads;
+#ifdef CONFIG_MOSIX
+		nlink -= count_guests();
+#endif /* CONFIG_MOSIX */
 
 		dir->i_nlink = nlink;
 	}
diff -Naur --exclude=CVS --exclude=configs linux/fs/readdir.c linux-openmosix/fs/readdir.c
--- linux/fs/readdir.c	2002-08-03 02:39:45.000000000 +0200
+++ linux-openmosix/fs/readdir.c	2004-02-05 10:51:21.000000000 +0100
@@ -5,6 +5,10 @@
  */
 
 #include <linux/sched.h>
+#ifdef CONFIG_MOSIX
+#include <linux/stddef.h>
+#include <linux/dirent.h>
+#endif /* CONFIG_MOSIX */
 #include <linux/mm.h>
 #include <linux/errno.h>
 #include <linux/stat.h>
@@ -13,6 +17,10 @@
 
 #include <asm/uaccess.h>
 
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 int vfs_readdir(struct file *file, filldir_t filler, void *buf)
 {
 	struct inode *inode = file->f_dentry->d_inode;
@@ -193,11 +201,30 @@
 		return -EINVAL;
 	buf->count++;
 	dirent = buf->dirent;
+#ifdef CONFIG_MOSIX
+	{
+		union
+		{
+			struct old_linux_dirent o;
+			struct dirent d;
+		} u;
+
+		u.o.d_ino = ino;
+		u.o.d_offset = offset;
+		u.o.d_namlen = namlen;
+		memcpy(u.d.d_name, name, namlen);
+		u.d.d_name[namlen] = '\0';
+		copy_to_user(dirent, &u,
+			offsetof(struct old_linux_dirent, d_name[0]) +
+				namlen + 1);
+	}
+#else
 	put_user(ino, &dirent->d_ino);
 	put_user(offset, &dirent->d_offset);
 	put_user(namlen, &dirent->d_namlen);
 	copy_to_user(dirent->d_name, name, namlen);
 	put_user(0, dirent->d_name + namlen);
+#endif /* CONFIG_MOSIX */
 	return 0;
 }
 
@@ -207,6 +234,9 @@
 	struct file * file;
 	struct readdir_callback buf;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -215,7 +245,13 @@
 	buf.count = 0;
 	buf.dirent = dirent;
 
+#ifdef CONFIG_MOSIX_FS
+	current->mosix.dirty_bits |= MFSARG_OLDREADDIR;
+#endif /* CONFIG_MOSIX_FS */
 	error = vfs_readdir(file, fillonedir, &buf);
+#ifdef CONFIG_MOSIX_FS
+	current->mosix.dirty_bits &= ~MFSARG_OLDREADDIR;
+#endif /* CONFIG_MOSIX_FS */
 	if (error >= 0)
 		error = buf.count;
 
@@ -250,6 +286,9 @@
 	struct linux_dirent * dirent;
 	struct getdents_callback * buf = (struct getdents_callback *) __buf;
 	int reclen = ROUND_UP(NAME_OFFSET(dirent) + namlen + 1);
+#ifdef CONFIG_MOSIX
+	struct dirent d;
+#endif /* CONFIG_MOSIX */
 
 	buf->error = -EINVAL;	/* only used if we fail.. */
 	if (reclen > buf->count)
@@ -260,9 +299,24 @@
 	dirent = buf->current_dir;
 	buf->previous = dirent;
 	put_user(ino, &dirent->d_ino);
+#ifdef CONFIG_MOSIX
+/* access to remote-data is much faster in one block */
+	d.d_reclen = reclen;
+	memcpy(d.d_name, name, namlen);
+	d.d_name[namlen] = '\0';
+/* NOTICE:
+We take great liberty to fill the potential round-up byte(s)
+that are not filled by standard Linux.
+SORRY - performance would be horrible otherwise with all the fragmentation.
+*/
+
+	copy_to_user(&dirent->d_reclen, &d.d_reclen,
+				reclen - offsetof(struct dirent, d_reclen));
+#else
 	put_user(reclen, &dirent->d_reclen);
 	copy_to_user(dirent->d_name, name, namlen);
 	put_user(0, dirent->d_name + namlen);
+#endif /* CONFIG_MOSIX */
 	((char *) dirent) += reclen;
 	buf->current_dir = dirent;
 	buf->count -= reclen;
@@ -276,6 +330,9 @@
 	struct getdents_callback buf;
 	int error;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -286,7 +343,14 @@
 	buf.count = count;
 	buf.error = 0;
 
+#ifdef CONFIG_MOSIX_FS
+	current->mosix.dirty_bits |= MFSARG_GETDENTS;
+	current->mosix.dirty_arg = count;
+#endif /* CONFIG_MOSIX_FS */
 	error = vfs_readdir(file, filldir, &buf);
+#ifdef CONFIG_MOSIX_FS
+	current->mosix.dirty_bits &= ~MFSARG_GETDENTS;
+#endif /* CONFIG_MOSIX_FS */
 	if (error < 0)
 		goto out_putf;
 	error = buf.error;
@@ -359,6 +423,9 @@
 	struct getdents_callback64 buf;
 	int error;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -369,7 +436,14 @@
 	buf.count = count;
 	buf.error = 0;
 
+#ifdef CONFIG_MOSIX_FS
+	current->mosix.dirty_bits |= MFSARG_GETDENTS64;
+	current->mosix.dirty_arg = count;
+#endif /* CONFIG_MOSIX_FS */
 	error = vfs_readdir(file, filldir64, &buf);
+#ifdef CONFIG_MOSIX_FS
+	current->mosix.dirty_bits &= ~MFSARG_GETDENTS64;
+#endif /* CONFIG_MOSIX_FS */
 	if (error < 0)
 		goto out_putf;
 	error = buf.error;
diff -Naur --exclude=CVS --exclude=configs linux/fs/read_write.c linux-openmosix/fs/read_write.c
--- linux/fs/read_write.c	2003-08-25 13:44:43.000000000 +0200
+++ linux-openmosix/fs/read_write.c	2004-02-05 10:51:21.000000000 +0100
@@ -29,6 +29,10 @@
 
 #include <asm/uaccess.h>
 
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 struct file_operations generic_ro_fops = {
 	llseek:		generic_file_llseek,
 	read:		generic_file_read,
@@ -91,7 +95,11 @@
 	return retval;
 }
 
+#ifdef CONFIG_MOSIX_FS
+inline loff_t llseek(struct file *file, loff_t offset, int origin)
+#else
 static inline loff_t llseek(struct file *file, loff_t offset, int origin)
+#endif /* CONFIG_MOSIX_FS */
 {
 	loff_t (*fn)(struct file *, loff_t, int);
 	loff_t retval;
@@ -110,6 +118,9 @@
 	off_t retval;
 	struct file * file;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 	retval = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -135,6 +146,9 @@
 	struct file * file;
 	loff_t offset;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 	retval = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -164,6 +178,9 @@
 	ssize_t ret;
 	struct file * file;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 	ret = -EBADF;
 	file = fget(fd);
 	if (file) {
@@ -189,6 +206,9 @@
 	ssize_t ret;
 	struct file * file;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 	ret = -EBADF;
 	file = fget(fd);
 	if (file) {
@@ -333,6 +353,9 @@
 	ssize_t ret;
 
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 	ret = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -353,6 +376,9 @@
 	ssize_t ret;
 
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 	ret = -EBADF;
 	file = fget(fd);
 	if (!file)
diff -Naur --exclude=CVS --exclude=configs linux/fs/stat.c linux-openmosix/fs/stat.c
--- linux/fs/stat.c	2003-08-25 13:44:43.000000000 +0200
+++ linux-openmosix/fs/stat.c	2004-02-05 10:51:21.000000000 +0100
@@ -13,6 +13,14 @@
 
 #include <asm/uaccess.h>
 
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs.h>
+#include <linux/slab.h>
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 /*
  * Revalidate the inode. This is required for proper NFS attribute caching.
  */
@@ -125,6 +133,14 @@
 		tmp.st_blocks = inode->i_blocks;
 		tmp.st_blksize = inode->i_blksize;
 	}
+#ifdef CONFIG_MOSIX_FS
+	if(inode->i_sb && inode->i_sb->s_magic == MFS_SUPER_MAGIC)
+	{
+		tmp.__unused1 = inode->u.mfs_i.pe;
+		tmp.__unused2 = inode->i_generation;
+		tmp.__unused3 = inode->i_version;
+	}
+#endif /* CONFIG_MOSIX_FS */
 	return copy_to_user(statbuf,&tmp,sizeof(tmp)) ? -EFAULT : 0;
 }
 
@@ -139,7 +155,28 @@
 	struct nameidata nd;
 	int error;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_STAT;
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_FOLLOW|
+					LOOKUP_STAYFS|LOOKUP_COMPLETE, &nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+	{
+		if(nd.complete_parg)
+		{
+			error = cp_old_stat((struct inode *)nd.complete_parg,
+								statbuf);
+			kfree(nd.complete_parg);
+		}
+		return(error);
+	}
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(filename,
+			LOOKUP_POSITIVE|LOOKUP_FOLLOW| LOOKUP_STAYFS, &nd);
+#else
 	error = user_path_walk(filename, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (!error) {
 		error = do_revalidate(nd.dentry);
 		if (!error)
@@ -155,7 +192,28 @@
 	struct nameidata nd;
 	int error;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_STAT;
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_FOLLOW|
+					LOOKUP_STAYFS|LOOKUP_COMPLETE, &nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+	{
+		if(nd.complete_parg)
+		{
+			error = cp_new_stat((struct inode *)nd.complete_parg,
+								statbuf);
+			kfree(nd.complete_parg);
+		}
+		return(error);
+	}
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(filename,
+			LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_STAYFS, &nd);
+#else
 	error = user_path_walk(filename, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (!error) {
 		error = do_revalidate(nd.dentry);
 		if (!error)
@@ -176,7 +234,27 @@
 	struct nameidata nd;
 	int error;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_STAT;
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_STAYFS|
+							LOOKUP_COMPLETE, &nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+	{
+		if(nd.complete_parg)
+		{
+			error = cp_old_stat((struct inode *)nd.complete_parg,
+								statbuf);
+			kfree(nd.complete_parg);
+		}
+		return(error);
+	}
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_STAYFS, &nd);
+#else
 	error = user_path_walk_link(filename, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (!error) {
 		error = do_revalidate(nd.dentry);
 		if (!error)
@@ -193,7 +271,27 @@
 	struct nameidata nd;
 	int error;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_STAT;
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_STAYFS|
+							LOOKUP_COMPLETE, &nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+	{
+		if(nd.complete_parg)
+		{
+			error = cp_new_stat((struct inode *)nd.complete_parg,
+								statbuf);
+			kfree(nd.complete_parg);
+		}
+		return(error);
+	}
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_STAYFS, &nd);
+#else
 	error = user_path_walk_link(filename, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (!error) {
 		error = do_revalidate(nd.dentry);
 		if (!error)
@@ -214,6 +312,9 @@
 	struct file * f;
 	int err = -EBADF;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 0);
+#endif /* CONFIG_MOSIX_DFSA */
 	f = fget(fd);
 	if (f) {
 		struct dentry * dentry = f->f_dentry;
@@ -233,6 +334,9 @@
 	struct file * f;
 	int err = -EBADF;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 0);
+#endif /* CONFIG_MOSIX_DFSA */
 	f = fget(fd);
 	if (f) {
 		struct dentry * dentry = f->f_dentry;
@@ -253,7 +357,21 @@
 	if (bufsiz <= 0)
 		return -EINVAL;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_READLINK;
+	nd.complete_args.buffer.buf = buf;
+	nd.complete_args.buffer.bufsiz = bufsiz;
+	error = __user_walk(path, LOOKUP_POSITIVE|LOOKUP_STAYFS|LOOKUP_COMPLETE,
+									&nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+		return(error);
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(path, LOOKUP_POSITIVE|LOOKUP_STAYFS, &nd);
+#else
 	error = user_path_walk_link(path, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (!error) {
 		struct inode * inode = nd.dentry->d_inode;
 
@@ -328,6 +446,14 @@
 		tmp.st_blocks = inode->i_blocks;
 		tmp.st_blksize = inode->i_blksize;
 	}
+#ifdef CONFIG_MOSIX_FS
+	if(inode->i_sb && inode->i_sb->s_magic == MFS_SUPER_MAGIC)
+	{
+		STAT64_NODE(tmp) = inode->u.mfs_i.pe;
+		STAT64_ORIGDEV(tmp) = inode->i_generation;
+		STAT64_ORIGINO(tmp) = inode->i_version;
+	}
+#endif /* CONFIG_MOSIX_FS */
 	return copy_to_user(statbuf,&tmp,sizeof(tmp)) ? -EFAULT : 0;
 }
 
@@ -336,7 +462,28 @@
 	struct nameidata nd;
 	int error;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_STAT;
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_FOLLOW|
+					LOOKUP_STAYFS|LOOKUP_COMPLETE, &nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+	{
+		if(nd.complete_parg)
+		{
+			error = cp_new_stat64((struct inode *)nd.complete_parg,
+								statbuf);
+			kfree(nd.complete_parg);
+		}
+		return(error);
+	}
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(filename,
+			LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_STAYFS, &nd);
+#else
 	error = user_path_walk(filename, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (!error) {
 		error = do_revalidate(nd.dentry);
 		if (!error)
@@ -351,7 +498,27 @@
 	struct nameidata nd;
 	int error;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_STAT;
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_STAYFS|
+							LOOKUP_COMPLETE, &nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+	{
+		if(nd.complete_parg)
+		{
+			error = cp_new_stat64((struct inode *)nd.complete_parg,
+								statbuf);
+			kfree(nd.complete_parg);
+		}
+		return(error);
+	}
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_STAYFS, &nd);
+#else
 	error = user_path_walk_link(filename, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (!error) {
 		error = do_revalidate(nd.dentry);
 		if (!error)
@@ -366,6 +533,9 @@
 	struct file * f;
 	int err = -EBADF;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 0);
+#endif /* CONFIG_MOSIX_DFSA */
 	f = fget(fd);
 	if (f) {
 		struct dentry * dentry = f->f_dentry;
diff -Naur --exclude=CVS --exclude=configs linux/fs/super.c linux-openmosix/fs/super.c
--- linux/fs/super.c	2003-08-25 13:44:43.000000000 +0200
+++ linux-openmosix/fs/super.c	2004-02-05 10:51:21.000000000 +0100
@@ -18,6 +18,7 @@
  *    Torbjörn Lindh (torbjorn.lindh@gopta.se), April 14, 1996.
  *  Added devfs support: Richard Gooch <rgooch@atnf.csiro.au>, 13-JAN-1998
  *  Heavily rewritten for 'one fs - one tree' dcache architecture. AV, Mar 2000
+ *  Changed to include trylock routing       openMosix Aug 23, 2002
  */
 
 #include <linux/config.h>
@@ -575,8 +576,13 @@
  * filesystems which don't use real block-devices.  -- jrs
  */
 
+#ifdef CONFIG_MOSIX_FS
+enum {Max_anon = 255};
+static unsigned long unnamed_dev_in_use[(Max_anon+1)/(8*sizeof(unsigned long))];
+#else
 enum {Max_anon = 256};
 static unsigned long unnamed_dev_in_use[Max_anon/(8*sizeof(unsigned long))];
+#endif /* CONFIG_MOSIX_FS */
 static spinlock_t unnamed_dev_lock = SPIN_LOCK_UNLOCKED;/* protects the above */
 
 /**
@@ -585,6 +591,10 @@
  */
 static void put_anon_dev(kdev_t dev)
 {
+#ifdef CONFIG_MOSIX_FS
+	if(MINOR(dev) == Max_anon)
+		return;
+#endif /*CONFIG_MOSIX_FS */
 	spin_lock(&unnamed_dev_lock);
 	clear_bit(MINOR(dev), unnamed_dev_in_use);
 	spin_unlock(&unnamed_dev_lock);
@@ -635,16 +645,25 @@
 		return old;
 	}
 
-	spin_lock(&unnamed_dev_lock);
-	dev = find_first_zero_bit(unnamed_dev_in_use, Max_anon);
-	if (dev == Max_anon) {
+#ifdef CONFIG_MOSIX_FS
+	if(!strcmp(type->name, "mfs"))
+		dev = mk_kdev(UNNAMED_MAJOR, Max_anon); /* changed from MKDEV to mk_kdev for 2.5 compat - Amit */
+	else
+	  {
+#endif /* CONFIG_MOSIX_FS */
+		spin_lock(&unnamed_dev_lock);
+		dev = find_first_zero_bit(unnamed_dev_in_use, Max_anon);
+		if (dev == Max_anon) {
+			spin_unlock(&unnamed_dev_lock);
+			spin_unlock(&sb_lock);
+			destroy_super(s);
+			return ERR_PTR(-EMFILE);
+		}
+		set_bit(dev, unnamed_dev_in_use);
 		spin_unlock(&unnamed_dev_lock);
-		spin_unlock(&sb_lock);
-		destroy_super(s);
-		return ERR_PTR(-EMFILE);
+#ifdef CONFIG_MOSIX_FS
 	}
-	set_bit(dev, unnamed_dev_in_use);
-	spin_unlock(&unnamed_dev_lock);
+#endif /* CONFIG_MOSIX_FS */
 
 	s->s_dev = dev;
 	insert_super(s, type);
